#ifndef  _AMR_LIB_H_
#define  _AMR_LIB_H_

#ifdef __cplusplus
extern "C" {
#endif

typedef enum _MODE
{ 
    MR475 = 0,
    MR515,            
    MR59,
    MR67,
    MR74,
    MR795,
    MR102,
    MR122,            
    N_MODES     /* number of (SPC) modes */
}MODE;


///////////////////////////////////////////////////////////////////////////////////////////
//  Usage:
//  The beginning of the proceedings should call AmrStartup().
//  The end of the process and then call AmrShutdown().
////////////////////////////////////////////////////////////////////////////////////////////
BOOL AmrStartup();
BOOL AmrShutdown();

////////////////////////////////////////////////////////////////////////////////////////////
//  The following are the main functions of a static library function
////////////////////////////////////////////////////////////////////////////////////////////
DWORD EncodeBuffer(BYTE* IN pBufFrame, DWORD IN dwBufLen, MODE IN mode, BYTE * OUT pPackedAmr);
BOOL RecordStart(TCHAR* IN szFileAmr, MODE IN mode);
BOOL RecordStop();
BOOL IsRecordComplete();

DWORD DecodeBuffer(BYTE* IN pBufAmr, DWORD IN dwBufLen, BYTE * OUT pWav);
BOOL PlayStart(TCHAR* IN szFileAmr);
BOOL PlayPause();
BOOL PlayStop();
BOOL IsPlayComplete();

BOOL GetAmrPlayTime(TCHAR *szAmrFile, UINT& uiTimeLen);

#ifdef __cplusplus
}
#endif

#endif