#include "stdafx.h"
#include <windows.h>
#include <commctrl.h>

#include "Example.h"
#include "amrlib.h"

#define MAX_LOADSTRING 100

// global
HINSTANCE			g_hInst;
HWND				g_hWndMenuBar;
HWND                s_hLoginDlg;

ATOM			MyRegisterClass(HINSTANCE, LPTSTR);
BOOL			InitInstance(HINSTANCE, int);
static BOOL CALLBACK DialogProc(const HWND hDlg, const UINT uiMessage, 
                                const WPARAM wParam, const LPARAM lParam);
static BOOL InitDialog(const HWND hDlg);


int WINAPI WinMain(HINSTANCE hInstance,
                   HINSTANCE hPrevInstance,
                   LPTSTR    lpCmdLine,
                   int       nCmdShow)
{
    g_hInst = hInstance;

    DialogBox(g_hInst,MAKEINTRESOURCE(IDD_DIALOG1), 0,(DLGPROC)DialogProc);

    return (int) 0;
}

#ifdef __cplusplus
extern "C" {
#endif

void DrawValue(int x, int value)
{
	RECT rect = {x, 0, 320, 20};
    PAINTSTRUCT	ps;
    wchar_t text[20];

    _itow(value, text, 10);

    HWND hWnd = GetForegroundWindow();

    InvalidateRect(hWnd, &rect, !true);

    HDC hdc = BeginPaint(hWnd, &ps);

	DrawText(hdc, text, _tcslen(text),&rect, DT_LEFT|DT_TOP); 

    EndPaint(hWnd, &ps);
    ValidateRect(hWnd, &rect);
}
#ifdef __cplusplus
}
#endif


/*********************************************************************************
 *
 *	GetCheckBoxValue
 *
 *********************************************************************************/
BOOL GetCheckBoxValue(HWND hwnd, int checkBoxID)
{
	// Send a message to the check box to see if it's checked or not
	HWND hwndCheck = GetDlgItem(hwnd, checkBoxID);

	if (hwndCheck &&
		BST_CHECKED == SendMessage(hwndCheck, BM_GETCHECK, 0, 0))
	{
		return true;		
	}

	return false;
}
void SetCheckBoxValue(HWND hwnd, int checkBoxID, unsigned short value)
{
	// Send a message to the check box to see if it's checked or not
	HWND hwndCheck = GetDlgItem(hwnd, checkBoxID);

    SendMessage(hwndCheck, BM_SETCHECK, value, 0);
}

/*********************************************************************************
 *
 *	InsertText
 *
 *********************************************************************************/
void InsertText(HWND hWnd, int id, const TCHAR * textP)
{
    if (textP)
        SendMessage(GetDlgItem(hWnd, id), EM_REPLACESEL , TRUE, (LPARAM)textP);
}


/*********************************************************************************
 *
 *	GetEditerText
 *
 *********************************************************************************/
TCHAR * GetEditerText(HWND hWnd, int id, TCHAR *buf, int bufSize)
{
    if (buf == NULL)
        return NULL;

    buf[0] = 0;
	SendDlgItemMessage(hWnd, id, WM_GETTEXT, bufSize, (LPARAM)buf);

	return buf;
}


/*********************************************************************************
 *
 *	InitDialog
 *
 *********************************************************************************/
static BOOL InitDialog(const HWND hDlg)
{
	// Specify that the dialog box should stretch full screen
	SHINITDLGINFO shidi;
	ZeroMemory(&shidi, sizeof(shidi));
    shidi.dwMask  = SHIDIM_FLAGS;
    shidi.dwFlags = SHIDIF_SIPDOWN | SHIDIF_SIZEDLGFULLSCREEN;
    shidi.hDlg    = hDlg;

	// Set up the menu bar
	SHMENUBARINFO shmbi;
	ZeroMemory(&shmbi, sizeof(shmbi));
    shmbi.cbSize     = sizeof(shmbi);
    shmbi.hwndParent = hDlg;
    shmbi.nToolBarId = IDR_MENU1;
    shmbi.hInstRes   = g_hInst;

	// If we could not initialize the dialog box, return an error
	if (!(SHInitDialog(&shidi) && SHCreateMenuBar(&shmbi))) 
    {
        return FALSE;
	}

	SetCheckBoxValue(hDlg, IDC_CHECK6, true);
	SetCheckBoxValue(hDlg, IDC_CHECK_PALY, true);

    InsertText(hDlg, IDC_EDIT2, TEXT(".\\test.amr"));

    return TRUE;
}


//	GetMode
MODE GetMode(const HWND hDlg)
{
	int id[] = {IDC_CHECK6,
				IDC_CHECK7,
				IDC_CHECK8,
				IDC_CHECK9,
				IDC_CHECK10,
				IDC_CHECK11,
				IDC_CHECK12,
				IDC_CHECK13};
	MODE mode[] = { MR475,
				MR515,
				MR59,
				MR67,
				MR74,
				MR795,
				MR102,
				MR122};

	for (int i = 0; i < (sizeof(id)/sizeof((id)[0])); i++)
	{
		if (GetCheckBoxValue(hDlg, id[i]))
			return mode[i];
	}

	return mode[0];
}


/*********************************************************************************
 *  
 *********************************************************************************/
static BOOL CALLBACK DialogProc(const HWND hDlg, const UINT uiMessage, 
                                const WPARAM wParam, const LPARAM lParam)
{
    BOOL    bHandled = true;
	
	switch(uiMessage)
	{
		case WM_INITDIALOG:
            s_hLoginDlg = hDlg;
            InitDialog(hDlg);
			if (!AmrStartup())
                DestroyWindow(hDlg);
			break;

		case WM_COMMAND:
			switch (LOWORD(wParam)) 
            {
            case IDC_CHECK_RECORD:
            case IDC_CHECK_PALY:
                SetCheckBoxValue(hDlg, IDC_CHECK_PALY, false);
                SetCheckBoxValue(hDlg, IDC_CHECK_RECORD, false);
                SetCheckBoxValue(hDlg, LOWORD(wParam), true);
                break;

            case IDC_CHECK6:
            case IDC_CHECK7:
            case IDC_CHECK8:
            case IDC_CHECK9:
            case IDC_CHECK10:
            case IDC_CHECK11:
            case IDC_CHECK12:
            case IDC_CHECK13:
                SetCheckBoxValue(hDlg, IDC_CHECK6, false);
                SetCheckBoxValue(hDlg, IDC_CHECK7, false);
                SetCheckBoxValue(hDlg, IDC_CHECK8, false);
                SetCheckBoxValue(hDlg, IDC_CHECK9, false);
                SetCheckBoxValue(hDlg, IDC_CHECK10, false);
                SetCheckBoxValue(hDlg, IDC_CHECK11, false);
                SetCheckBoxValue(hDlg, IDC_CHECK12, false);
                SetCheckBoxValue(hDlg, IDC_CHECK13, false);
                SetCheckBoxValue(hDlg, LOWORD(wParam), true);
                break;
            
            case IDB_START:
            {
                TCHAR  name[266];
                GetEditerText(hDlg, IDC_EDIT2, name, sizeof(name));

                if (GetCheckBoxValue(hDlg, IDC_CHECK_PALY))
                {
                    // playing, stop recording
                    RecordStop();
                    PlayStop();         // stop the old play
                    PlayStart(name);    // paly new one
                }
                else
                {
                    // recording, stop playing
                    PlayStop();
                    if (IsRecordComplete())
                        RecordStart(name, GetMode(hDlg));
                    else
                        RecordStop();
                }
                break;
            }

            case IDB_EXIT:
            {
				UINT uiTimeLen = 0;
				TCHAR  name[266];
				GetEditerText(hDlg, IDC_EDIT2, name, sizeof(name));
				GetAmrPlayTime(name, uiTimeLen);
				DrawValue(0, uiTimeLen);
				Sleep(1000);

				DestroyWindow(hDlg);
                break;
            }
            }
			break;
		
		case WM_DESTROY:
			AmrShutdown();
			break;

		case WM_CLOSE:	
            DestroyWindow(hDlg);
			break;

		default:
			// nothing was processed
			bHandled = false;
			break;
	}

	return bHandled;
}
